<template>
  <single-pane :capt="dictionaryRu.title">
    <ob-table
      :columns="columnsObTable"
      :functionalPanel="true"
      :remote-opt="getObTableData"
      is-fixed-header
      @select="onSelection"
      ref="obTable"
    />
    <ob-modal
      ref="viewItem"
      :title="dictionaryRu.modal.title"
      :is-show-pagination="true"
      :is-read-only="true"
    >
      <modal
        v-if="selectedData.uuid"
        :selected-data="selectedData"
        :api="api"
        @refresh="onRefresh"
      />
    </ob-modal>
  </single-pane>
</template>

<script>
import paging     from '@/mixins/dictionaries/paging';
import itemMixin  from '@/mixins/dictionaries/edit-item';
import SinglePane from 'common-components/src/obComponents/obSinglePanels';
import ObModal    from 'common-components/src/obComponents/obModal';
import ObTable    from 'common-components/src/obComponents/obTable';
import Modal      from './modal';
import { dictionaryDefault } from '@/translations/ru/default';
import { dictionary } from '@/translations/ru/dictionaries__resources__tracking_methods';


export default {
  name: 'TrackingMethods',
  components: {
    Modal,
    ObModal,
    ObTable,
    SinglePane,
  },

  mixins: [
    paging,
    itemMixin
  ],

  data() {
    return {
      api: {
        source: '/oboz2-dictionary-tracking-methods-viewer/v1/'
      },
      dictionaryRu: Object.assign(dictionary, dictionaryDefault)
    };
  },

  computed: {
    columnsObTable() {
      return [
        {
          title: this.dictionaryRu.columns.denomination,
          key: 'denomination',
          html: data => {
            return `<div class="flex jc-fs al-i-c">
              <img src="${this.getDeviceIconByType({ type: data.code })}" alt="" />
              <span class="pl-10">${data.denomination}</span>
            </div>`;
          }
        },
        {
          title: this.dictionaryRu.columns.code,
          key: 'code'
        },
        {
          title: this.dictionaryRu.columns.description,
          key: 'description'
        },
        {
          title: this.dictionaryRu.columns.status,
          width: 110,
          key: 'is_active',
          html: data => {
            return data.is_active
              ? this.dictionaryRu.status.active
              : this.dictionaryRu.status.inactive;
          }
        }
      ];
    },
  },

  methods: {
    getDeviceIconByType({ type = 'government', active = true } = {}) {
      const iconMap = {
        government_seal: 'state',
        govseal        : 'state',
        government     : 'state',
        onboard_device : 'onboard',
        odbdev         : 'onboard',
        onboard        : 'onboard',
        mobapp         : 'mobile-app',
        mobile_app     : 'mobile-app',
        mobile_tel     : 'mobile-tel',
        moviz          : 'mobile-tel',
        mobile_phone   : 'mobile-tel',
        comseal        : 'commercial',
        commercial_seal: 'commercial',
        commercial     : 'commercial',
        commerce       : 'commercial',
      }

      const name = iconMap[type.toLowerCase()] || 'state'
      const color = active ? '_blue' : '_gray';

      return require(`@/static/images/tracking-devices/${name}${color}.svg`);
    }
  },
};
</script>